<?php
#-----------------------------------------------------#
#          ********* ROTORCMS *********               #
#              Made by  :  VANTUZ                     #
#               E-mail  :  visavi.net@mail.ru         #
#                 Site  :  http://pizdec.ru           #
#             WAP-Site  :  http://visavi.net          #
#                  ICQ  :  36-44-66                   #
#  Вы не имеете право вносить изменения в код скрипта #
#        для его дальнейшего распространения          #
#-----------------------------------------------------#	
require_once ('../includes/start.php');
require_once ('../includes/functions.php');
require_once ('../includes/header.php');
include_once ('../themes/' . $config['themes'] . '/index.php');

if (isset($_GET['tid'])) {
  $tid = abs(intval($_GET['tid']));
} else {
  $tid = 0;
} 
if (isset($_GET['start'])) {
  $start = abs(intval($_GET['start']));
} else {
  $start = 0;
} 
if (isset($_GET['act'])) {
  $act = check($_GET['act']);
} else {
  $act = 'index';
} 

show_title('menu.png', 'Форум ' . $config['title']);

switch ($act):
# ###########################################################################################
# #                                    Главная страница                                    ##
# ###########################################################################################
case "index":

  $querytopic = DB :: $dbh -> query("SELECT `topics`.*, `forums`.`forums_id`, `forums`.`forums_title`, `forums`.`forums_parent` FROM `topics` LEFT JOIN `forums` ON `topics`.`topics_forums_id`=`forums`.`forums_id` WHERE `topics_id`=? LIMIT 1;", array($tid));
  $topics = $querytopic -> fetch();

  if ($topics > 0) {
    $config['newtitle'] = $topics['topics_title'];

    echo '<a href="#down"><img src="../images/img/downs.gif" alt="Вниз" /></a> ';
    echo '<a href="index.php?' . SID . '">Форум</a> / ';

    if (!empty($topics['forums_parent'])) {
      $queryforum = DB :: $dbh -> query("SELECT `forums_id`, `forums_title` FROM `forums` WHERE `forums_id`=? LIMIT 1;", array($topics['forums_parent']));
      $forums = $queryforum -> fetch();
      echo '<a href="forum.php?fid=' . $forums['forums_id'] . '&amp;' . SID . '">' . $forums['forums_title'] . '</a> / ';
    } 

    echo '<a href="forum.php?fid=' . $topics['forums_id'] . '&amp;' . SID . '">' . $topics['forums_title'] . '</a> / ';
    echo '<a href="topic.php?tid=' . $tid . '&amp;start=' . $start . '&amp;rand=' . mt_rand(1000, 9999) . '&amp;' . SID . '">Обновить</a> / ';
    echo '<a href="print.php?tid=' . $tid . '&amp;' . SID . '">Скачать</a> / <a href="rss.php?tid=' . $tid . '&amp;' . SID . '">RSS-лента</a><br /><br />';

    echo '<img src="../images/img/themes.gif" alt="image" /> <b>' . $topics['topics_title'] . '</b>';

    if ($topics['topics_author'] == $log && $topics['topics_closed'] != 1 && $udata['users_point'] >= $config['editforumpoint']) {
      echo ' (<a href="topic.php?act=closed&amp;tid=' . $tid . '&amp;start=' . $start . '&amp;uid=' . $_SESSION['token'] . '&amp;' . SID . '">Закрыть</a> / <a href="topic.php?act=edittopic&amp;tid=' . $tid . '&amp;' . SID . '">Изменить</a>)';
    } 

    if (!empty($topics['topics_mod'])) {
      $topics_mod = explode(',', $topics['topics_mod']);

      echo '<br />Кураторы темы: ';
      foreach ($topics_mod as $mkey => $mval) {
        if ($mkey == 0) {
          $comma = '';
        } else {
          $comma = ', ';
        } 
        echo $comma . nickname($mval);
      } 
      $moder = (in_array($log, $topics_mod)) ? 1 : 0;
    } else {
      $moder = 0;
    } 

    echo '<hr />';

    if (is_admin()) {
      if (empty($topics['topics_closed'])) {
        echo '<a href="' . ADMINDIR . 'forum.php?act=acttopic&amp;do=closed&amp;tid=' . $tid . '&amp;start=' . $start . '&amp;uid=' . $_SESSION['token'] . '&amp;' . SID . '">Закрыть</a> / ';
      } else {
        echo '<a href="' . ADMINDIR . 'forum.php?act=acttopic&amp;do=open&amp;tid=' . $tid . '&amp;start=' . $start . '&amp;uid=' . $_SESSION['token'] . '&amp;' . SID . '">Открыть</a> / ';
      } 

      if (empty($topics['topics_locked'])) {
        echo '<a href="' . ADMINDIR . 'forum.php?act=acttopic&amp;do=locked&amp;tid=' . $tid . '&amp;start=' . $start . '&amp;uid=' . $_SESSION['token'] . '&amp;' . SID . '">Закрепить</a> / ';
      } else {
        echo '<a href="' . ADMINDIR . 'forum.php?act=acttopic&amp;do=unlocked&amp;tid=' . $tid . '&amp;start=' . $start . '&amp;uid=' . $_SESSION['token'] . '&amp;' . SID . '">Открепить</a> / ';
      } 

      echo '<a href="' . ADMINDIR . 'forum.php?act=edittopic&amp;tid=' . $tid . '&amp;start=' . $start . '&amp;' . SID . '">Изменить</a> / ';
      echo '<a href="' . ADMINDIR . 'forum.php?act=movetopic&amp;tid=' . $tid . '&amp;' . SID . '">Переместить</a> / ';
      echo '<a href="' . ADMINDIR . 'forum.php?act=deltopics&amp;fid=' . $topics['forums_id'] . '&amp;del=' . $tid . '&amp;uid=' . $_SESSION['token'] . '&amp;' . SID . '" onclick="return confirm(\'Вы действительно хотите удалить данную тему?\')">Удалить</a> / ';
      echo '<a href="' . ADMINDIR . 'forum.php?act=topic&amp;tid=' . $tid . '&amp;start=' . $start . '&amp;' . SID . '">Управление</a><br />';
    } 

    $total = DB :: $dbh -> querySingle("SELECT count(*) FROM `posts` WHERE `posts_topics_id`=?;", array($tid));

    if ($total > 0) {
      if ($start >= $total) {
        $start = 0;
      } 

      $page = floor(1 + $start / $config['forumpost']);
      $config['newtitle'] = $topics['topics_title'] . ' (Стр. ' . $page . ')';
      $config['description'] = 'Обсуждение темы: ' . $topics['topics_title'] . ' (Стр. ' . $page . ')';

      if ($moder == 1) {
        echo '<form action="topic.php?act=del&amp;tid=' . $tid . '&amp;start=' . $start . '&amp;uid=' . $_SESSION['token'] . '&amp;' . SID . '" method="post">';
      } 

      $querypost = DB :: $dbh -> query("SELECT * FROM `posts` WHERE `posts_topics_id`=? ORDER BY `posts_time` ASC LIMIT " . $start . ", " . $config['forumpost'] . ";", array($tid));

      $i = 0;
      while ($data = $querypost -> fetch()) {
        ++$i;

        echo '<div class="b">';

        echo '<div class="img">';
        if ($moder == 1) {
          echo '<input type="checkbox" name="del[]" value="' . $data['posts_id'] . '" /> ';
        } 

        echo user_avatars($data['posts_user']) . '</div>';

        $num = ($start + $i);

        echo $num . '. <b><a href="../pages/anketa.php?uz=' . $data['posts_user'] . '&amp;' . SID . '">' . nickname($data['posts_user']) . '</a></b>  <small>(' . date_fixed($data['posts_time']) . ')</small><br />';
        echo user_title($data['posts_user']) . ' ' . user_online($data['posts_user']) . '</div>';

        if (!empty($log) && $log != $data['posts_user']) {
          echo '<div class="right">';
          echo '<a href="topic.php?act=reply&amp;tid=' . $tid . '&amp;pid=' . $data['posts_id'] . '&amp;start=' . $start . '&amp;num=' . $num . '&amp;' . SID . '">Отв</a> / ';
          echo '<a href="topic.php?act=quote&amp;tid=' . $tid . '&amp;pid=' . $data['posts_id'] . '&amp;start=' . $start . '&amp;' . SID . '">Цит</a> / ';
          echo '<a href="topic.php?act=spam&amp;tid=' . $tid . '&amp;pid=' . $data['posts_id'] . '&amp;start=' . $start . '&amp;uid=' . $_SESSION['token'] . '&amp;' . SID . '" onclick="return confirm(\'Вы подтверждаете факт спама?\')">Спам</a></div>';
        } 

        if ($log == $data['posts_user'] && $data['posts_time'] + 600 > SITETIME) {
          echo '<div class="right">';
          echo '<a href="topic.php?act=edit&amp;tid=' . $tid . '&amp;pid=' . $data['posts_id'] . '&amp;start=' . $start . '&amp;' . SID . '">Редактировать</a></div>';
        } 

        echo '<div>' . bb_code($data['posts_text']) . '<br />';

        if (!empty($data['posts_edit'])) {
          echo '<img src="../images/img/exclamation_small.gif" alt="image" /> <small>Отредактировано: ' . nickname($data['posts_edit']) . ' (' . date_fixed($data['posts_edit_time']) . ')</small><br />';
        } 

        if (is_admin() || empty($config['anonymity'])) {
          echo '<span class="data">(' . $data['posts_brow'] . ', ' . $data['posts_ip'] . ')</span>';
        } 

        echo '</div>';
      } 

      if ($moder == 1) {
        echo '<br /><input type="submit" value="Удалить выбранное" /></form>';
      } 

      page_strnavigation('topic.php?tid=' . $tid . '&amp;', $config['forumpost'], $start, $total);
    } else {
      show_error('Сообщений еще нет, будь первым!');
    } 

    if (is_user()) {
      if ($topics['topics_closed'] == 0) {
        echo '<div class="form" id="form">';
        echo '<form action="topic.php?act=add&amp;tid=' . $tid . '&amp;start=' . $start . '&amp;uid=' . $_SESSION['token'] . '&amp;' . SID . '" name="form" method="post">';
        echo 'Сообщение:<br />';
        echo '<textarea cols="25" rows="3" name="msg" id="msg"></textarea><br />';

        if (!empty($udata['users_bbpanel'])) {
          quickpaste('msg');
          quickcode();
          quicksmiles();
        } 

        echo '<input type="submit" value="Написать" /></form></div><br />';
      } else {
        show_error('Данная тема закрыта для обсуждения!');
      } 
    } else {
      show_login('Вы не авторизованы, чтобы добавить сообщение, необходимо');
    } 
  } else {
    show_error('Ошибка! Данной темы не существует!');
  } 

  echo '<a href="#up"><img src="../images/img/ups.gif" alt="up" /></a> ';
  echo '<a href="../pages/smiles.php?' . SID . '">Смайлы</a>  / ';
  echo '<a href="../pages/tegi.php?' . SID . '">Теги</a>  / ';
  echo '<a href="../pages/rules.php?' . SID . '">Правила</a> / ';
  echo '<a href="top.php?act=themes&amp;' . SID . '">Топ тем</a> / ';
  echo '<a href="search.php?fid=' . $topics['forums_id'] . '&amp;' . SID . '">Поиск</a><br />';

  break;
# ###########################################################################################
# #                                   Добавление сообщения                                 ##
# ###########################################################################################
case "add":

  $msg = check($_POST['msg']);
  $uid = check($_GET['uid']);

  if (is_user()) {
    if ($uid == $_SESSION['token']) {
      if (utf_strlen($msg) >= 5 && utf_strlen($msg) <= $config['forumtextlength']) {
        $topics = DB :: $dbh -> queryFetch("SELECT `topics`.*, `forums`.`forums_parent` FROM `topics` LEFT JOIN `forums` ON `topics`.`topics_forums_id`=`forums`.`forums_id` WHERE `topics`.`topics_id`=? LIMIT 1;", array($tid));

        if (!empty($topics)) {
          if (empty($topics['topics_closed'])) {
            if (is_quarantine($log)) {
              if (is_flood($log)) {
                $msg = no_br($msg);
                $msg = antimat($msg);
                $msg = smiles($msg);

                $post = DB :: $dbh -> queryFetch("SELECT * FROM `posts` WHERE `posts_topics_id`=? ORDER BY `posts_id` DESC LIMIT 1;", array($tid));
                if ($msg != $post['posts_text']) {
                  if ($log == $post['posts_user'] && $post['posts_time'] + 600 > SITETIME && (utf_strlen($msg) + utf_strlen($post['posts_text']) <= $config['forumtextlength'])) {
                    $newpost = $post['posts_text'] . '<br /><br />[i][small]Добавлено через ' . maketime(SITETIME - $post['posts_time']) . ' сек.[/small][/i]<br />' . $msg;

                    DB :: $dbh -> query("UPDATE `posts` SET `posts_text`=? WHERE `posts_id`=? LIMIT 1;", array($newpost, $post['posts_id']));
                  } else {
                    DB :: $dbh -> query("UPDATE `users` SET `users_allforum`=`users_allforum`+1, `users_point`=`users_point`+1, `users_money`=`users_money`+5 WHERE `users_login`=? LIMIT 1;", array($log));

                    DB :: $dbh -> query("INSERT INTO `posts` (`posts_topics_id`, `posts_forums_id`, `posts_user`, `posts_text`, `posts_time`, `posts_ip`, `posts_brow`) VALUES (?, ?, ?, ?, ?, ?, ?);", array($tid, $topics['topics_forums_id'], $log, $msg, SITETIME, $ip, $brow));

                    DB :: $dbh -> query("UPDATE `topics` SET `topics_posts`=`topics_posts`+1, `topics_last_user`=?, `topics_last_time`=? WHERE `topics_id`=?", array($log, SITETIME, $tid));

                    DB :: $dbh -> query("UPDATE `forums` SET `forums_posts`=`forums_posts`+1, `forums_last_id`=?, `forums_last_themes`=?, `forums_last_user`=?, `forums_last_time`=? WHERE `forums_id`=?;", array($tid, $topics['topics_title'], $log, SITETIME, $topics['topics_forums_id']));
                    // Обновление родительского форума
                    if ($topics['forums_parent'] > 0) {
                      DB :: $dbh -> query("UPDATE `forums` SET `forums_last_id`=?, `forums_last_themes`=?, `forums_last_user`=?, `forums_last_time`=? WHERE `forums_id`=?;", array($tid, $topics['topics_title'], $log, SITETIME, $topics['forums_parent']));
                    } 
                  } 

                  $_SESSION['note'] = 'Сообщение успешно добавлено!';
                  header ("Location: topic.php?act=end&tid=$tid&" . SID);
                  exit;
                } else {
                  show_error('Ошибка! Ваше сообщение повторяет предыдущий пост!');
                } 
              } else {
                show_error('Антифлуд! Разрешается отправлять сообщения раз в ' . flood_period() . ' секунд!');
              } 
            } else {
              show_error('Карантин! Вы не можете писать в течении ' . round($config['karantin'] / 3600) . ' часов!');
            } 
          } else {
            show_error('Ошибка! Запрещено писать в закрытую тему!');
          } 
        } else {
          show_error('Ошибка! Выбранная вами тема не существует, возможно она была удалена!');
        } 
      } else {
        show_error('Ошибка! Слишком длинное или короткое сообщение!');
      } 
    } else {
      show_error('Ошибка! Неверный идентификатор сессии, повторите действие!');
    } 
  } else {
    show_login('Вы не авторизованы, чтобы добавить сообщение, необходимо');
  } 

  echo '<img src="../images/img/back.gif" alt="image" /> <a href="topic.php?tid=' . $tid . '&amp;start=' . $start . '&amp;' . SID . '">Вернуться</a><br />';
  break;
# ###########################################################################################
# #                                    Жалоба на спам                                      ##
# ###########################################################################################
case "spam":

  $uid = check($_GET['uid']);
  $pid = abs(intval($_GET['pid']));

  if (is_user()) {
    if ($uid == $_SESSION['token']) {
      $queryguest = DB :: $dbh -> query("SELECT * FROM `posts` WHERE `posts_id`=? LIMIT 1;", array($pid));
      $data = $queryguest -> fetch();

      if (!empty($data)) {
        $queryspam = DB :: $dbh -> querySingle("SELECT `spam_id` FROM `spam` WHERE `spam_key`=? AND `spam_idnum`=? LIMIT 1;", array(1, $pid));

        if (empty($queryspam)) {
          if (is_flood($log)) {
            DB :: $dbh -> query("INSERT INTO `spam` (`spam_key`, `spam_idnum`, `spam_user`, `spam_login`, `spam_text`, `spam_time`, `spam_addtime`, `spam_link`) VALUES (?, ?, ?, ?, ?, ?, ?, ?);", array(1, $data['posts_id'], $log, $data['posts_user'], $data['posts_text'], $data['posts_time'], SITETIME, $config['home'] . '/forum/topic.php?tid=' . $tid . '&amp;start=' . $start));

            $_SESSION['note'] = 'Жалоба успешно отправлена!';
            header ("Location: topic.php?tid=$tid&start=$start&" . SID);
            exit;
          } else {
            show_error('Антифлуд! Разрешается жаловаться на спам не чаще чем раз в ' . flood_period() . ' секунд!');
          } 
        } else {
          show_error('Ошибка! Жалоба на данное сообщение уже отправлена!');
        } 
      } else {
        show_error('Ошибка! Выбранное вами сообщение для жалобы не существует!');
      } 
    } else {
      show_error('Ошибка! Неверный идентификатор сессии, повторите действие!');
    } 
  } else {
    show_login('Вы не авторизованы, чтобы подать жалобу, необходимо');
  } 

  echo '<img src="../images/img/back.gif" alt="image" /> <a href="topic.php?tid=' . $tid . '&amp;start=' . $start . '&amp;' . SID . '">Вернуться</a><br />';
  break;
# ###########################################################################################
# #                                    Удаление сообщений                                  ##
# ###########################################################################################
case "del":
  $uid = check($_GET['uid']);
  if (isset($_POST['del'])) {
    $del = intar($_POST['del']);
  } else {
    $del = 0;
  } 

  if (is_user()) {
    if ($uid == $_SESSION['token']) {
      if ($del > 0) {
        $querytopic = DB :: $dbh -> query("SELECT * FROM `topics` WHERE `topics_id`=? LIMIT 1;", array($tid));
        $topics = $querytopic -> fetch();

        $minposts = DB :: $dbh -> querySingle("SELECT min(`posts_id`) FROM `posts` WHERE `posts_topics_id`=?;", array($tid));

        if (!empty($topics['topics_mod'])) {
          $topics_mod = explode(',', $topics['topics_mod']);
          if (in_array($log, $topics_mod)) {
            if (!in_array($minposts, $del)) {
              $del = implode(',', $del);

              $delposts = DB :: $dbh -> exec("DELETE FROM `posts` WHERE `posts_id` IN (" . $del . ") AND `posts_topics_id`=" . $tid . ";");
              DB :: $dbh -> query("UPDATE `topics` SET `topics_posts`=`topics_posts`-? WHERE `topics_id`=?", array($delposts, $tid));
              DB :: $dbh -> query("UPDATE `forums` SET `forums_posts`=`forums_posts`-? WHERE `forums_id`=?", array($delposts, $topics['topics_forums_id']));

              $_SESSION['note'] = 'Выбранные сообщения успешно удалены!';
              header ("Location: topic.php?tid=$tid&start=$start&" . SID);
              exit;
            } else {
              show_error('Ошибка! Первое сообщение в теме удалять запрещено!');
            } 
          } else {
            show_error('Ошибка! Удалять сообщения могут только кураторы темы!');
          } 
        } else {
          show_error('Ошибка! В данной теме отсутствуют кураторы!');
        } 
      } else {
        show_error('Ошибка! Отстутствуют выбранные сообщения для удаления!');
      } 
    } else {
      show_error('Ошибка! Неверный идентификатор сессии, повторите действие!');
    } 
  } else {
    show_login('Вы не авторизованы, чтобы добавить сообщение, необходимо');
  } 

  echo '<img src="../images/img/back.gif" alt="image" /> <a href="topic.php?tid=' . $tid . '&amp;start=' . $start . '&amp;' . SID . '">Вернуться</a><br />';
  break;
# ###########################################################################################
# #                                       Закрытие темы                                    ##
# ###########################################################################################
case "closed":

  $uid = check($_GET['uid']);

  if ($uid == $_SESSION['token']) {
    if (is_user()) {
      if ($udata['users_point'] >= $config['editforumpoint']) {
        $querytopic = DB :: $dbh -> query("SELECT * FROM `topics` WHERE `topics_id`=? LIMIT 1;", array($tid));
        $topics = $querytopic -> fetch();

        if (!empty($topics)) {
          if ($topics['topics_author'] == $log) {
            if (empty($topics['topics_closed'])) {
              DB :: $dbh -> query("UPDATE `topics` SET `topics_closed`=? WHERE `topics_id`=?;", array(1, $tid));

              $_SESSION['note'] = 'Тема успешно закрыта!';
              header ("Location: topic.php?tid=$tid&start=$start&" . SID);
              exit;
            } else {
              show_error('Ошибка! Данная тема уже закрыта!');
            } 
          } else {
            show_error('Ошибка! Вы не автор данной темы!');
          } 
        } else {
          show_error('Ошибка! Выбранная вами тема не существует, возможно она была удалена!');
        } 
      } else {
        show_error('Ошибка! У вас недостаточно актива для закрытия тем!');
      } 
    } else {
      show_login('Вы не авторизованы, чтобы закрывать темы, необходимо');
    } 
  } else {
    show_error('Ошибка! Неверный идентификатор сессии, повторите действие!');
  } 

  echo '<img src="../images/img/back.gif" alt="image" /> <a href="topic.php?tid=' . $tid . '&amp;start=' . $start . '&amp;' . SID . '">Вернуться</a><br />';
  break;
# ###########################################################################################
# #                                   Ответ на сообщение                                   ##
# ###########################################################################################
case "reply":

  $pid = abs(intval($_GET['pid']));
  $num = abs(intval($_GET['num']));

  echo '<b><big>Ответ на сообщение</big></b><br /><br />';

  if (is_user()) {
    $post = DB :: $dbh -> queryFetch("SELECT `posts`.*, `topics`.`topics_closed` FROM `posts` LEFT JOIN `topics` ON `posts`.`posts_topics_id`=`topics`.`topics_id` WHERE `posts_id`=? LIMIT 1;", array($pid));

    if (!empty($post)) {
      if (empty($post['topics_closed'])) {
        echo '<div class="b"><img src="../images/img/edit.gif" alt="image" /> <b><a href="../pages/anketa.php?uz=' . $post['posts_user'] . '&amp;' . SID . '">' . nickname($post['posts_user']) . '</a></b> ' . user_title($post['posts_user']) . ' ' . user_online($post['posts_user']) . ' <small>(' . date_fixed($post['posts_time']) . ')</small></div>';
        echo '<div>Сообщение: ' . bb_code($post['posts_text']) . '</div><hr />';

        echo '<div class="form" id="form">';
        echo '<form action="topic.php?act=add&amp;tid=' . $post['posts_topics_id'] . '&amp;start=' . $start . '&amp;uid=' . $_SESSION['token'] . '&amp;' . SID . '" name="form" method="post">';
        echo 'Сообщение:<br />';
        echo '<textarea cols="25" rows="5" name="msg" id="msg">' . $num . '. [b]' . nickname($post['posts_user']) . '[/b], </textarea><br />';

        if (!empty($udata['users_bbpanel'])) {
          quickpaste('msg');
          quickcode();
          quicksmiles();
        } 

        echo '<input type="submit" value="Ответить" /></form></div><br />';
      } else {
        show_error('Данная тема закрыта для обсуждения!');
      } 
    } else {
      show_error('Ошибка! Выбранное вами сообщение для ответа не существует!');
    } 
  } else {
    show_login('Вы не авторизованы, чтобы отвечать на сообщения, необходимо');
  } 

  echo '<a href="#up"><img src="../images/img/ups.gif" alt="up" /></a> ';
  echo '<a href="../pages/smiles.php?' . SID . '">Смайлы</a>  / ';
  echo '<a href="../pages/tegi.php?' . SID . '">Теги</a>  / ';
  echo '<a href="../pages/rules.php?' . SID . '">Правила</a><br />';

  echo '<img src="../images/img/back.gif" alt="image" /> <a href="topic.php?tid=' . $tid . '&amp;start=' . $start . '&amp;' . SID . '">Вернуться</a><br />';
  break;
# ###########################################################################################
# #                                   Цитирование сообщения                                ##
# ###########################################################################################
case "quote":

  $pid = abs(intval($_GET['pid']));

  echo '<b><big>Цитирование</big></b><br /><br />';
  if (is_user()) {
    $post = DB :: $dbh -> queryFetch("SELECT `posts`.*, `topics`.`topics_closed` FROM `posts` LEFT JOIN `topics` ON `posts`.`posts_topics_id`=`topics`.`topics_id` WHERE `posts_id`=? LIMIT 1;", array($pid));

    if (!empty($post)) {
      if (empty($post['topics_closed'])) {
        $post['posts_text'] = nosmiles($post['posts_text']);
        $post['posts_text'] = preg_replace('|\[q\](.*?)\[/q\](<br />)?|', '', $post['posts_text']);
        $post['posts_text'] = str_replace('<br />', "\r\n", $post['posts_text']);

        echo '<div class="form" id="form">';
        echo '<form action="topic.php?act=add&amp;tid=' . $post['posts_topics_id'] . '&amp;start=' . $start . '&amp;uid=' . $_SESSION['token'] . '&amp;' . SID . '" name="form" method="post">';
        echo 'Сообщение:<br />';
        echo '<textarea cols="25" rows="5" name="msg" id="msg">[q][b]' . nickname($post['posts_user']) . '[/b] (' . date_fixed($post['posts_time'], 'j F Y / H:i') . ')' . "\r\n" . $post['posts_text'] . '[/q]' . "\r\n" . '</textarea><br />';

        if (!empty($udata['users_bbpanel'])) {
          quickpaste('msg');
          quickcode();
          quicksmiles();
        } 

        echo '<input type="submit" value="Цитировать" /></form></div><br />';
      } else {
        show_error('Данная тема закрыта для обсуждения!');
      } 
    } else {
      show_error('Ошибка! Выбранное вами сообщение для цитирования не существует!');
    } 
  } else {
    show_login('Вы не авторизованы, чтобы цитировать сообщения, необходимо');
  } 

  echo '<a href="#up"><img src="../images/img/ups.gif" alt="up" /></a> ';
  echo '<a href="../pages/smiles.php?' . SID . '">Смайлы</a>  / ';
  echo '<a href="../pages/tegi.php?' . SID . '">Теги</a>  / ';
  echo '<a href="../pages/rules.php?' . SID . '">Правила</a><br />';

  echo '<img src="../images/img/back.gif" alt="image" /> <a href="topic.php?tid=' . $tid . '&amp;start=' . $start . '&amp;' . SID . '">Вернуться</a><br />';
  break;
# ###########################################################################################
# #                                   Подготовка к изменению                               ##
# ###########################################################################################
case "edittopic":

  echo '<b><big>Изменение темы</big></b><br /><br />';

  if (is_user()) {
    if ($udata['users_point'] >= $config['editforumpoint']) {
      $topics = DB :: $dbh -> queryFetch("SELECT * FROM `topics` WHERE `topics_id`=? LIMIT 1;", array($tid));

      if (!empty($topics)) {
        if ($topics['topics_author'] == $log) {
          if (empty($topics['topics_closed'])) {
            $post = DB :: $dbh -> queryFetch("SELECT * FROM `posts` WHERE `posts_topics_id`=? ORDER BY posts_id ASC LIMIT 1;", array($tid));
            if (!empty($post)) {
              $post['posts_text'] = nosmiles($post['posts_text']);
              $post['posts_text'] = yes_br($post['posts_text']);

              echo '<img src="../images/img/edit.gif" alt="image" /> <b>' . nickname($post['posts_user']) . '</b> <small>(' . date_fixed($post['posts_time']) . ')</small><br /><br />';

              echo '<div class="form" id="form">';
              echo '<form action="topic.php?act=changetopic&amp;tid=' . $post['posts_topics_id'] . '&amp;uid=' . $_SESSION['token'] . '&amp;' . SID . '" name="form" method="post">';

              echo 'Заголовок:<br />';
              echo '<input type="text" name="title" size="50" maxlength="50" value="' . $topics['topics_title'] . '" /><br />';
              echo 'Сообщение:<br />';
              echo '<textarea cols="25" rows="5" name="msg" id="msg">' . $post['posts_text'] . '</textarea><br />';

              if (!empty($udata['users_bbpanel'])) {
                quickpaste('msg');
                quickcode();
                quicksmiles();
              } 

              echo '<input value="Редактировать" name="do" type="submit" /></form></div><br />';
            } else {
              show_error('Ошибка! Первого сообщения в теме не существует!');
            } 
          } else {
            show_error('Ошибка! Изменение невозможно, данная тема закрыта!');
          } 
        } else {
          show_error('Ошибка! Изменение невозможно, вы не автор данной темы!');
        } 
      } else {
        show_error('Ошибка! Выбранная вами тема не существует, возможно она была удалена!');
      } 
    } else {
      show_error('Ошибка! У вас недостаточно актива для изменения темы!');
    } 
  } else {
    show_login('Вы не авторизованы, чтобы редактировать сообщения, необходимо');
  } 

  echo '<a href="#up"><img src="../images/img/ups.gif" alt="up" /></a> ';
  echo '<a href="../pages/smiles.php?' . SID . '">Смайлы</a>  / ';
  echo '<a href="../pages/tegi.php?' . SID . '">Теги</a>  / ';
  echo '<a href="../pages/rules.php?' . SID . '">Правила</a><br />';

  echo '<img src="../images/img/back.gif" alt="image" /> <a href="topic.php?tid=' . $tid . '&amp;' . SID . '">Вернуться</a><br />';
  break;
# ###########################################################################################
# #                                  Изменение темы и сообщения                            ##
# ###########################################################################################
case "changetopic":

  $uid = check($_GET['uid']);
  $title = check($_POST['title']);
  $msg = check($_POST['msg']);

  if (is_user()) {
    if ($uid == $_SESSION['token']) {
      if ($udata['users_point'] >= $config['editforumpoint']) {
        $querytopic = DB :: $dbh -> query("SELECT * FROM `topics` WHERE `topics_id`=? LIMIT 1;", array($tid));
        $topics = $querytopic -> fetch();

        if (!empty($topics)) {
          if ($topics['topics_author'] == $log) {
            if (empty($topics['topics_closed'])) {
              $minposts = DB :: $dbh -> querySingle("SELECT MIN(`posts_id`) FROM `posts` WHERE `posts_topics_id`=?;", array($tid));
              if (!empty($minposts)) {
                if (utf_strlen($title) >= 5 && utf_strlen($title) <= 50) {
                  if (utf_strlen($msg) >= 5 && utf_strlen($msg) <= $config['forumtextlength']) {
                    $msg = no_br($msg);
                    $msg = antimat($msg);
                    $msg = smiles($msg);

                    DB :: $dbh -> query("UPDATE `topics` SET `topics_title`=? WHERE topics_id=?;", array($title, $tid));
                    DB :: $dbh -> query("UPDATE `posts` SET `posts_user`=?, `posts_text`=?, `posts_ip`=?, `posts_brow`=?, `posts_edit`=?, `posts_edit_time`=? WHERE `posts_id`=?", array($log, $msg, $ip, $brow, $log, SITETIME, $minposts));

                    $_SESSION['note'] = 'Тема успешно изменена!';
                    header ("Location: topic.php?tid=$tid&" . SID);
                    exit;
                  } else {
                    show_error('Ошибка! Слишком длинное или короткое сообщение!');
                  } 
                } else {
                  show_error('Ошибка! Слишком длинный или короткий заголовок темы!');
                } 
              } else {
                show_error('Ошибка! Первого сообщения в теме не существует!');
              } 
            } else {
              show_error('Ошибка! Изменение невозможно, данная тема закрыта!');
            } 
          } else {
            show_error('Ошибка! Изменение невозможно, вы не автор данной темы!');
          } 
        } else {
          show_error('Ошибка! Выбранная вами тема не существует, возможно она была удалена!');
        } 
      } else {
        show_error('Ошибка! У вас недостаточно актива для зменения темы!');
      } 
    } else {
      show_error('Ошибка! Неверный идентификатор сессии, повторите действие!');
    } 
  } else {
    show_login('Вы не авторизованы, чтобы редактировать сообщения, необходимо');
  } 

  echo '<img src="../images/img/back.gif" alt="image" /> <a href="topic.php?act=edittopic&amp;tid=' . $tid . '&amp;' . SID . '">Вернуться</a><br />';
  break;
# ###########################################################################################
# #                                Подготовка к редактированию                             ##
# ###########################################################################################
case "edit":

  $pid = abs(intval($_GET['pid']));

  if (is_user()) {
    $querypost = DB :: $dbh -> query("SELECT * FROM `posts` WHERE `posts_id`=? AND `posts_user`=? LIMIT 1;", array($pid, $log));
    $post = $querypost -> fetch();

    if (!empty($post)) {
      if ($post['posts_time'] + 600 > SITETIME) {
        $post['posts_text'] = nosmiles($post['posts_text']);
        $post['posts_text'] = str_replace('<br />', "\r\n", $post['posts_text']);

        echo '<img src="../images/img/edit.gif" alt="image" /> <b>' . nickname($post['posts_user']) . '</b> <small>(' . date_fixed($post['posts_time']) . ')</small><br /><br />';

        echo '<div class="form" id="form">';
        echo '<form action="topic.php?act=editpost&amp;tid=' . $post['posts_topics_id'] . '&amp;pid=' . $pid . '&amp;start=' . $start . '&amp;uid=' . $_SESSION['token'] . '&amp;' . SID . '" name="form" method="post">';
        echo 'Редактирование сообщения:<br />';
        echo '<textarea cols="25" rows="5" name="msg" id="msg">' . $post['posts_text'] . '</textarea><br />';

        if (!empty($udata['users_bbpanel'])) {
          quickpaste('msg');
          quickcode();
          quicksmiles();
        } 

        echo '<input value="Редактировать" name="do" type="submit" /></form></div><br />';
      } else {
        show_error('Ошибка! Редактирование невозможно, прошло более 10 минут!!');
      } 
    } else {
      show_error('Ошибка! Сообщение удалено или вы не автор этого сообщения!');
    } 
  } else {
    show_login('Вы не авторизованы, чтобы редактировать сообщения, необходимо');
  } 

  echo '<a href="#up"><img src="../images/img/ups.gif" alt="up" /></a> ';
  echo '<a href="../pages/smiles.php?' . SID . '">Смайлы</a>  / ';
  echo '<a href="../pages/tegi.php?' . SID . '">Теги</a>  / ';
  echo '<a href="../pages/rules.php?' . SID . '">Правила</a><br />';

  echo '<img src="../images/img/back.gif" alt="image" /> <a href="topic.php?tid=' . $tid . '&amp;start=' . $start . '&amp;' . SID . '">Вернуться</a><br />';
  break;
# ###########################################################################################
# #                                    Редактирование сообщения                            ##
# ###########################################################################################
case "editpost":

  $uid = check($_GET['uid']);
  $pid = abs(intval($_GET['pid']));
  $msg = check($_POST['msg']);

  if (is_user()) {
    if ($uid == $_SESSION['token']) {
      if (utf_strlen($msg) >= 5 && utf_strlen($msg) <= $config['forumtextlength']) {
        $querypost = DB :: $dbh -> query("SELECT * FROM `posts` WHERE `posts_id`=? AND `posts_user`=? LIMIT 1;", array($pid, $log));
        $post = $querypost -> fetch();

        if (!empty($post)) {
          if ($post['posts_time'] + 600 > SITETIME) {
            $msg = no_br($msg);
            $msg = antimat($msg);
            $msg = smiles($msg);

            DB :: $dbh -> query("UPDATE `posts` SET `posts_text`=?, `posts_edit`=?, `posts_edit_time`=? WHERE `posts_id`=?", array($msg, $log, SITETIME, $pid));

            $_SESSION['note'] = 'Сообщение успешно отредактировано!';
            header ("Location: topic.php?tid=$tid&start=$start&" . SID);
            exit;
          } else {
            show_error('Ошибка! Редактирование невозможно, прошло более 10 минут!!');
          } 
        } else {
          show_error('Ошибка! Сообщение удалено или вы не автор этого сообщения!');
        } 
      } else {
        show_error('Ошибка! Слишком длинное или короткое сообщение!');
      } 
    } else {
      show_error('Ошибка! Неверный идентификатор сессии, повторите действие!');
    } 
  } else {
    show_login('Вы не авторизованы, чтобы редактировать сообщения, необходимо');
  } 

  echo '<img src="../images/img/back.gif" alt="image" /> <a href="topic.php?act=edit&amp;tid=' . $tid . '&amp;pid=' . $pid . '&amp;start=' . $start . '&amp;' . SID . '">Вернуться</a><br />';
  break;
# ###########################################################################################
# #                                     Переход к сообщению                                ##
# ###########################################################################################
case 'viewpost':

  if (isset($_GET['id'])) {
    $id = abs(intval($_GET['id']));
  } else {
    $id = 0;
  } 
  if (isset($_GET['tid'])) {
    $tid = abs(intval($_GET['tid']));
  } else {
    $tid = 0;
  } 

  $querytopic = DB :: $dbh -> querySingle("SELECT COUNT(*) FROM `posts` WHERE `posts_id`<=? AND `posts_topics_id`=? ORDER BY `posts_time` ASC LIMIT 1;", array($id, $tid));

  if (!empty($querytopic)) {
    $end = floor(($querytopic - 1) / $config['forumpost']) * $config['forumpost'];

    header ("Location: topic.php?tid=$tid&start=$end&" . SID);
    exit;
  } else {
    show_error('Ошибка! Выбранная вами тема не существует, возможно она была удалена!');
  } 
  break;
# ###########################################################################################
# #                             Переадресация на последнюю страницу                        ##
# ###########################################################################################
case "end":

  $querytopic = DB :: $dbh -> querySingle("SELECT `topics_posts` FROM `topics` WHERE `topics_id`=? LIMIT 1;", array($tid));

  if (!empty($querytopic)) {
    $end = floor(($querytopic - 1) / $config['forumpost']) * $config['forumpost'];

    header ("Location: topic.php?tid=$tid&start=$end&" . SID);
    exit;
  } else {
    show_error('Ошибка! Выбранная вами тема не существует, возможно она была удалена!');
  } 
  break;

default:
  header("location: index.php?" . SID);
  exit;
  endswitch;

  echo '<img src="../images/img/reload.gif" alt="image" /> <a href="index.php?' . SID . '">К форумам</a><br />';
  echo '<img src="../images/img/homepage.gif" alt="image" /> <a href="../index.php?' . SID . '">На главную</a>';

  include_once ('../themes/' . $config['themes'] . '/foot.php');

  ?>